xmonad-contrib-0.13: Third party extensions for xmonad

Copyright | (c) 2007 Andrea Rossato
License | BSD-style (see xmonad/LICENSE)
Maintainer | andrea.rossato@unibz.it
Stability | unstable
Portability | unportable
Safe Haskell | None
Language | Haskell98

XMonad.Layout.SimpleFloat

Contents

- Usage:

Description

A basic floating layout.

Synopsis

- simpleFloat :: Eq a => ModifiedLayout (Decoration SimpleDecoration DefaultShrinker) (ModifiedLayout MouseResize (ModifiedLayout WindowArranger SimpleFloat)) a
- simpleFloat' :: (Eq a, Shrinker s) => s -> Theme -> ModifiedLayout (Decoration SimpleDecoration s) (ModifiedLayout MouseResize (ModifiedLayout WindowArranger SimpleFloat)) a
- data SimpleDecoration a = Simple Bool
- data SimpleFloat a = SF Dimension
- shrinkText :: DefaultShrinker
- data CustomShrink = CustomShrink
- class (Read s, Show s) => Shrinker s where

# Usage:

You can use this module with the following in your `~/.xmonad/xmonad.hs`:

    import XMonad.Layout.SimpleFloat

Then edit your `layoutHook` by adding the SimpleFloat layout:

    myLayout = simpleFloat ||| Full ||| etc..
    main = xmonad def { layoutHook = myLayout }

For more detailed instructions on editing the layoutHook see:

XMonad.Doc.Extending

simpleFloat :: Eq a => ModifiedLayout (Decoration SimpleDecoration DefaultShrinker) (ModifiedLayout MouseResize (ModifiedLayout WindowArranger SimpleFloat)) a #

A simple floating layout where every window is placed according to the window's initial attributes.

This version is decorated with the `SimpleDecoration` style.

simpleFloat' :: (Eq a, Shrinker s) => s -> Theme -> ModifiedLayout (Decoration SimpleDecoration s) (ModifiedLayout MouseResize (ModifiedLayout WindowArranger SimpleFloat)) a #

Same as `simpleFloat`, but with the possibility of setting a custom shrinker and a custom theme.

data SimpleDecoration a #

Constructors

Simple Bool |

Instances

Eq a => DecorationStyle SimpleDecoration a # |
Methods describeDeco :: SimpleDecoration a -> String # shrink :: SimpleDecoration a -> Rectangle -> Rectangle -> Rectangle # decorationEventHook :: SimpleDecoration a -> DecorationState -> Event -> X () # decorationCatchClicksHook :: SimpleDecoration a -> Window -> Int -> Int -> X Bool # decorationWhileDraggingHook :: SimpleDecoration a -> CInt -> CInt -> (Window, Rectangle) -> Position -> Position -> X () # decorationAfterDraggingHook :: SimpleDecoration a -> (Window, Rectangle) -> Window -> X () # pureDecoration :: SimpleDecoration a -> Dimension -> Dimension -> Rectangle -> Stack a -> [(a, Rectangle)] -> (a, Rectangle) -> Maybe Rectangle # decorate :: SimpleDecoration a -> Dimension -> Dimension -> Rectangle -> Stack a -> [(a, Rectangle)] -> (a, Rectangle) -> X (Maybe Rectangle) #
Read (SimpleDecoration a) # |
Methods readsPrec :: Int -> ReadS (SimpleDecoration a) # readList :: ReadS [SimpleDecoration a] # readPrec :: ReadPrec (SimpleDecoration a) # readListPrec :: ReadPrec [SimpleDecoration a] #
Show (SimpleDecoration a) # |
Methods showsPrec :: Int -> SimpleDecoration a -> ShowS # show :: SimpleDecoration a -> String # showList :: [SimpleDecoration a] -> ShowS #

data SimpleFloat a #

Constructors

SF Dimension |

Instances

LayoutClass SimpleFloat Window # |
Methods runLayout :: Workspace WorkspaceId (SimpleFloat Window) Window -> Rectangle -> X ([(Window, Rectangle)], Maybe (SimpleFloat Window)) # doLayout :: SimpleFloat Window -> Rectangle -> Stack Window -> X ([(Window, Rectangle)], Maybe (SimpleFloat Window)) # pureLayout :: SimpleFloat Window -> Rectangle -> Stack Window -> [(Window, Rectangle)] # emptyLayout :: SimpleFloat Window -> Rectangle -> X ([(Window, Rectangle)], Maybe (SimpleFloat Window)) # handleMessage :: SimpleFloat Window -> SomeMessage -> X (Maybe (SimpleFloat Window)) # pureMessage :: SimpleFloat Window -> SomeMessage -> Maybe (SimpleFloat Window) # description :: SimpleFloat Window -> String #
Read (SimpleFloat a) # |
Methods readsPrec :: Int -> ReadS (SimpleFloat a) # readList :: ReadS [SimpleFloat a] # readPrec :: ReadPrec (SimpleFloat a) # readListPrec :: ReadPrec [SimpleFloat a] #
Show (SimpleFloat a) # |
Methods showsPrec :: Int -> SimpleFloat a -> ShowS # show :: SimpleFloat a -> String # showList :: [SimpleFloat a] -> ShowS #

shrinkText :: DefaultShrinker #

data CustomShrink #

Constructors

CustomShrink |

Instances

Read CustomShrink # |
Methods readsPrec :: Int -> ReadS CustomShrink # readList :: ReadS [CustomShrink] # readPrec :: ReadPrec CustomShrink # readListPrec :: ReadPrec [CustomShrink] #
Show CustomShrink # |
Methods showsPrec :: Int -> CustomShrink -> ShowS # show :: CustomShrink -> String # showList :: [CustomShrink] -> ShowS #

class (Read s, Show s) => Shrinker s where #

Minimal complete definition

shrinkIt

Methods

shrinkIt :: s -> String -> [String] #

Instances

Shrinker DefaultShrinker # |
Methods shrinkIt :: DefaultShrinker -> String -> [String] #